import router from './router'
import store from './store'
import NProgress from 'nprogress' // progress bar
import { Notify } from 'vant'
import 'nprogress/nprogress.css' // progress bar style
import { getToken } from '@/utils/auth' // get token from cookie

NProgress.configure({ showSpinner: false }) // NProgress Configuration

const whiteList = ['/login', '/resetpassword', '/help'] // no redirect whitelist

// eslint-disable-next-line prettier/prettier
router.beforeEach(async(to, from, next) => {
  // start progress bar
  NProgress.start()
  // set page title

  // determine whether the user has logged in
  const hasToken = getToken()

  if (hasToken) {
    if (to.path === '/login') {
      // if is logged in, redirect to the home page

      next({ path: '/' })
      NProgress.done()
    } else {
      debugger
      const userinfo = store.getters.userinfo && Object.keys(store.getters.userinfo).length > 0
      console.log(store.getters)
      console.log(userinfo)
      if (userinfo) {
        next()
      } else {
        try {
          // 获取用户信息
          store.dispatch('user/getInfo')
          // // 根据角色生成可访问的路线图
          next({ ...to, replace: true })
        } catch (error) {
          // remove token and go to login page to re-login
          await store.dispatch('user/resetToken')
          Notify({ type: 'danger', message: error || '发生异常' })
          next(`/login?redirect=${to.path}`)
          NProgress.done()
        }
      }
    }
  } else {
    // next()
    /* has no token*/
    if (whiteList.indexOf(to.path) !== -1) {
      // in the free login whitelist, go directly
      next()
    } else {
      //   // other pages that do not have permission to access are redirected to the login page.
      next(`/login?redirect=${to.path}`)
      NProgress.done()
    }
  }
})

router.afterEach(() => {
  // finish progress bar
  NProgress.done()
})
